.\"	$NetBSD: isa.4,v 1.39 2005/06/28 08:42:32 wiz Exp $
.\"
.\" Copyright (c) 1997 Jason R. Thorpe.  All rights reserved.
.\" Copyright (c) 1997 Jonathan Stone
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgements:
.\"      This product includes software developed by Jonathan Stone
.\" 4. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd June 28, 2005
.Dt ISA 4
.Os
.Sh NAME
.Nm isa
.Nd introduction to machine-independent ISA bus support and drivers
.Sh SYNOPSIS
Attachments are machine-dependent and depend on the bus topology and
.Tn ISA
bus interface of your system.
See
.Xr intro 4
for your system for details.
.Sh DESCRIPTION
.Nx
includes a machine-independent
.Tn ISA
bus subsystem and several machine-independent
.Tn ISA
device drivers.
.Pp
Your system may support additional
.Tn ISA
devices.
Drivers for
.Tn ISA
devices not listed here are machine-dependent.  Consult your system's
.Xr intro 4
for additional information.
.Sh SUPPORTED DEVICES
.Nx
includes machine-independent
.Tn ISA
drivers, sorted by device type and driver name:
.Ss SCSI interfaces
.Bl -tag -width pcdisplay -offset indent
.It adv
Advansys
.Tn SCSI
interfaces.
.It aha
Adaptec AHA-154x family (154xA, 154xB, 154xC, and 154xCF) and the
BusLogic BT54x
.Tn SCSI
interfaces.
.It ahc
Adaptec 29xx, 39xx, and other AIC-7xxx-based
.Tn SCSI
interfaces.
.It aic
Adaptec AIC-6260 and Adaptec AIC-6360 based
.Tn SCSI
interfaces, including
the Adaptec 152x, SoundBlaster
.Tn SCSI
interfaces, and a variety of compatibles.
.It bha
BusLogic BT-445
.Tn SCSI
interfaces.
.It dpt
DPT SmartCache/SmartRAID III and IV
.Tn SCSI
interfaces.
.It esp
NCR 53C9x, Emulex ESP406, and Qlogic FAS408
.Tn SCSI
interfaces.
.It nca
NCR-5380/NCR-53C400
.It sea
Seagate/Future Domain
.Tn SCSI
cards.
ST01/02, Future Domain TMC-885, and Future Domain TMC-950.
.It uha
Ultrastor 14f
.Tn SCSI
interfaces.
.It wds
WD-7000 family of bus-mastering
.Tn SCSI
interfaces.
.El
.Ss Disk and tape controllers
.Bl -tag -width pcdisplay -offset indent
.It mcd
Mitsumi CD-ROM drives.
.It wdc
Standard Western Digital type hard drive controllers: MFM, RLL, ESDI,
and IDE/ATAPI.
.It wt
Wangtek and compatible QIC-02 and QIC-36 tape drives.
.El
.Ss Serial and parallel interfaces
.Bl -tag -width pcdisplay -offset indent
.It ast
Multi-port serial communications card first made by AST.
.It boca
Boca BB100[48] and BB2016 multiplexing serial communications cards.
.It com
NS8250-, NS16450-, and NS16550-based serial ports.
.It cy
Cyclades Cyclom-4Y, -8Y, and -16Y asynchronous serial communications cards.
.It ioat
.Tn BOCA Research
IOAT66
serial interfaces.
.It lpt
Standard
.Tn ISA
parallel port interface.
.It rtfps
IBM RT four-port serial interfaces.
.It tcom
Byte Runner Technologies TC-400 and TC-800 series serial interfaces.
.El
.Ss Network interfaces
.Bl -tag -width pcdisplay -offset indent
.It ai
.Tn AT\*[Am]T
.Tn StarLan
.Tn Ethernet
interfaces.
.It ate
Allied Telesis AT1700 series and RE2000 series
.Tn Ethernet
interfaces.
.It cs
.Tn Cirrus Logic
Crystal CS8900
.Tn Ethernet
interfaces.
.It ec
3Com EtherLink II (3c503)
.Tn Ethernet
interfaces.
.It ef
.Tn 3Com
EtherLink II (3c507)
.Tn Ethernet
interfaces.
.It eg
3Com EtherLink Plus (3c505)
.Tn Ethernet
interfaces.
.It el
3Com EtherLink (3c501)
.Tn Ethernet
interfaces.
.It ep
3Com EtherLink III (3c509)
.Tn Ethernet
interfaces.
.It fmv
Fujitsu FMV-181 and FMV-182 interfaces.
.\".It hp
.\" Broken driver for HP -relabelled
.\" .Tn Ethernet
.\" cards.
.It ix
Intel EtherExpress/16
.Tn Ethernet
interfaces.
.It iy
Intel i82595-based
.Tn Ethernet
interfaces, including the EtherExpress Pro/10.
.It lc
DEC EtherWORKS III
.Tn Ethernet
interfaces (DE203, DE204, and DE205).
.It le
.Tn Ethernet
interfaces based on the AMD LANCE chip,
including BICC Isolan, Novell NE2100, Digital DEPCA, and PCnet-ISA.
.It ne
Novel NE2000 and compatible
.Tn Ethernet
interfaces.
.It ntwoc
SDL Communications Riscom/N2 synchronous serial interfaces.
.It sm
SMC91C9x-based
.Tn Ethernet
interfaces.
.It tr
TROPIC based token ring interfaces.
.It we
Western Digital/SMC 80x3, SMC Elite Ultra, and SMC EtherEZ
.Tn Ethernet
interfaces.
.El
.Ss Sound cards and MIDI interfaces
.Bl -tag -width pcdisplay -offset indent
.It aria
Sierra's Aria based sound cards.
.It cms
Creative Music System.
.It ess
ESS Technology AudioDrive 1788-, 1888-, 1887-, and 888-based sound cards.
.It gus
Gravis Ultrasound sound cards.
.It mpu
Roland MPU401 (and compatible) MIDI UARTs.
.It opl
Yamaha OPL2 and OPL3 FM MIDI synthesizers.
.It pas
ProAudio Spectrum sound cards.
.It sb
SoundBlaster, SoundBlaster 16, and SoundBlaster Pro sound cards.
.It wss
Windows Sound System-compatible sound cards based on the AD1848 and
compatible chips.
.El
.Ss Miscellaneous devices
.Bl -tag -width pcdisplay -offset indent
.It az
Aztech/PackardBell radio card.
.It ega
EGA graphics boards.
.It lm
National Semiconductor LM78, LM79 and compatible hardware monitors.
.It pcdisplay
PC display adapters.
.It pcic
.Tn PCI
.Tn PCMCIA
controllers, including the Cirrus Logic GD6729.
.It pckbc
PC keyboard controllers.
.It pcppi
PC control and timer ports.
.It pms
PS/2 auxiliary port mice (including wheel mice).
.It rt
AIMS Lab Radiotrack FM radio.
.It rtii
AIMS Lab Radiotrack II FM radio.
.It sf2r
SoundForte RadioLink SF16-FMR2 FM radio.
.It tcic
Databook DB86082, DB86084, DB86184, and DB86072
.Tn PCMCIA
controllers.
.It vga
VGA graphics boards.
.El
.Pp
Note that some
.Tn ISA
devices also have newer
.Tn ISA
Plug-and-Play variants.
These are listed in
.Xr isapnp 4 .
Some i386 platforms use
.Xr pnpbios 4
to attach
.Tn ISA
devices.
.Sh DIAGNOSTICS
.Bl -diag
.It "Stray interrupt on IRQ 7"
It means the interrupt controller reported an unmasked interrupt on IRQ
7, but no driver attached to that IRQ `claimed' it.
.Pp
There are two reasons this can happen:
.Bl -bullet
.It
In anything other than i386, it would almost always mean that there is a
driver attached to the IRQ, but it is the wrong driver.
.It
On i386, there is the more obscure issue of `default IRQ7's.
That is, when a device asserts an IRQ, but the IRQ is deasserted
after the PIC latches the interrupt and before the CPU acknowledges
it, the PIC just flat out lies about which IRQ it was.
It is usually due to a suboptimally coded driver.
.El
.El
.Sh SEE ALSO
.Xr adv 4 ,
.Xr aha 4 ,
.Xr ahc 4 ,
.Xr ai 4 ,
.Xr aic 4 ,
.Xr aria 4 ,
.Xr ast 4 ,
.Xr ate 4 ,
.Xr az 4 ,
.Xr bha 4 ,
.Xr boca 4 ,
.Xr cms 4 ,
.Xr com 4 ,
.Xr cs 4 ,
.Xr cy 4 ,
.Xr dpt 4 ,
.Xr ec 4 ,
.Xr ef 4 ,
.Xr eg 4 ,
.Xr el 4 ,
.Xr ep 4 ,
.Xr esp 4 ,
.Xr ess 4 ,
.Xr fmv 4 ,
.Xr gus 4 ,
.Xr intro 4 ,
.Xr ioat 4 ,
.Xr isapnp 4 ,
.Xr ix 4 ,
.Xr iy 4 ,
.Xr joy 4 ,
.Xr lc 4 ,
.Xr le 4 ,
.Xr lm 4 ,
.Xr lpt 4 ,
.Xr mcd 4 ,
.Xr mpu 4 ,
.Xr nca 4 ,
.Xr ne 4 ,
.Xr ntwoc 4 ,
.Xr opl 4 ,
.Xr pas 4 ,
.Xr pcdisplay 4 ,
.Xr pcic 4 ,
.Xr pckbc 4 ,
.Xr pcppi 4 ,
.Xr pms 4 ,
.Xr pnpbios 4 ,
.Xr rt 4 ,
.Xr rtfps 4 ,
.Xr rtii 4 ,
.Xr sb 4 ,
.Xr sea 4 ,
.Xr sf2r 4 ,
.Xr sm 4 ,
.Xr tcic 4 ,
.Xr tcom 4 ,
.Xr tr 4 ,
.Xr uha 4 ,
.Xr vga 4 ,
.Xr wd 4 ,
.Xr wdc 4 ,
.Xr wds 4 ,
.Xr we 4 ,
.Xr wss 4 ,
.Xr wt 4
.Sh HISTORY
The machine-independent
.Tn ISA
subsystem appeared in
.Nx 1.2 .
